{{log "actionV2/action-tab-main.hbs THIS===" this}}

<div class="flexrow sheet-header">
    <img class="action-image" style="margin-right: 6px;" src="{{action.img}}" data-edit="img" />
    <input class="charname" name="name" type="text" value="{{action.name}}" placeholder="Name" />
    <a class="content-link" style="border: none;margin-left: auto; flex-basis: 15px;flex-grow:0;" data-link=""
        draggable="true" data-uuid={{@root.config.HELP.action.general.uuid}}
        data-id={{@root.config.HELP.action.general.id}} data-type={{@root.config.HELP.actor.action.general.type}}
        data-pack={{@root.config.HELP.action.general.pack}} data-tooltip="Documentation: Actions"><i
            class="{{@root.config.HELP.action.general.icon}}"></i></a>
</div>

<div class="action-titles">
    <li class="action-header flexrow">

        <div style="flex: 0 0 100px" class="action-type">Type</div>
        {{#includes action.type 'melee||ranged||thrown||castmelee||castranged||damage'}}
            <div class="action-ability">Ability</div>
        {{/includes}}

        {{#includes action.type 'castshape'}}
            <div class="shape-shape-range">{{localize "ARS.actions.castshape.targetSelection"}}
            </div>
            <div class="shape-shape-range">{{localize "ARS.actions.castshape.range"}}
            </div>
        {{/includes}}
        {{#includes action.type 'cast||castmelee||castranged'}}
            <div class="action-success">Success Action</div>
        {{/includes}}
        {{#includes action.type 'cast||melee||thrown||ranged||castmelee||castranged'}}
            <div class="action-speed">Speed</div>
        {{/includes}}
        {{#if (eq action.type 'damage')}}
            <div class="action-damagetype">Damage Type</div>
        {{/if}}
        {{#includes action.type 'castshape||effect||item-effect||damage||heal'}}
            <div class="action-effect-misc">Details</div>
        {{/includes}}
    </li>
</div>

<div class="action-list">
    <li class="actions-list-data flexrow">
        <div style="flex: 0 0 100px" class="action-type">
            <select class="action-type-select" style="width: 100px;" name="type">
                {{selectOptions config.actions.types selected=action.type localize=true}}
            </select>
        </div>
        {{#includes action.type 'melee||ranged||thrown||castmelee||castranged||damage'}}
            <div class="action-ability">
                <select name="ability">
                    {{selectOptions config.actions.abilityTypes selected=action.ability localize=true}}
                </select>
            </div>
        {{/includes}}

        {{#includes action.type 'castshape'}}
            <div class="action-shape-target">
                <div class="action-shape-target">
                    <select name="castShape.selection.type">
                        {{selectOptions config.targetShapeSelection selected=action.castShape.selection.type localize=true}}
                    </select>
                </div>
            </div>
            <div class="action-shape-range">
                <div class="action-shape-range">
                    <input name="castShape.properties.range.formula" type="text"
                        value="{{action.castShape.properties.range.formula}}" placeholder="0" />
                </div>
            </div>
        {{/includes}}
        {{#includes action.type 'cast||castmelee||castranged'}}
            <div class="action-targeting-success">
                <select name="successAction">
                    {{selectOptions config.successAction selected=action.successAction localize=true}}
                </select>
            </div>
        {{/includes}}
        {{#includes action.type 'cast||melee||ranged||thrown||castmelee||castranged'}}
            <div class="action-speed">
                <input name="speed" type="number" value="{{action.speed}}" data-dtype="Number" />
            </div>
        {{/includes}}
        {{#if (eq action.type 'damage')}}
            <div class="action-damagetype">
                <select name="damagetype">
                    {{selectOptions config.weaponDamageTypes selected=action.damagetype localize=true}}
                </select>
            </div>
        {{/if}}

        {{#includes action.type 'castshape||effect||item-effect||damage||heal'}}
            <div class="action-misc">
                <input name="misc" type="text" value="{{action.misc}}" data-dtype="String"
                    placeholder="Short Description" />
            </div>
        {{/includes}}
    </li>
</div>

{{#includes action.type 'melee||ranged||thrown||damage||heal'}}
    <div class="action-items">
        <div class="action-list">
            <li class="action-header flexrow">
                <div class="action-formula">Formula</div>
            </li>

            <div class="actions-list">
                <li class="actions-list-data flexrow">
                    <div class="action-formula">
                        <input size="4" name="formula" type="text" value="{{action.formula}}" />
                    </div>
                </li>
            </div>
        </div>
    </div>
{{/includes}}

{{#includes action.type "cast||castmelee||castranged||melee||ranged||thrown||use"}}
    <div class="action-list">
        <li class="action-header flexrow">
            <div class="resource-title-name">Resource</div>
            {{#if (eq action.resource.type 'none') }}
            {{else}}
                <div style="flex: 0 0 100px" class="action-resource-type">Type</div>
                {{#if (eq action.resource.type 'charged') }}
                    <div style="flex: 0 0 100px" class="action-resource-reuse">Reuse</div>
                {{/if}}
                <div class="action-resource-cost">Cost</div>
                {{#includes action.resource.type "item||powered"}}
                    <div style="flex: 0 0 100px" class="action-resource-item">Item</div>
                {{/includes}}
                {{#if (eq action.resource.type 'charged') }}
                    <div class="action-resource-value">Count</div>
                    <div class="action-resource-max">Max</div>
                {{/if}}
            {{/if}}
        </li>
        <div class="actions-list">
            <li class="actions-list-data flexrow">
                <div class="action-resource-trunc" style="margin: auto;">
                    <a class="content-link" style="border:none" data-link="" draggable="true"
                        data-hash={{@root.config.HELP.action.resources.hash}}
                        data-uuid={{@root.config.HELP.action.resources.uuid}}
                        data-id={{@root.config.HELP.action.resources.id}}
                        data-type={{@root.config.HELP.actor.action.resources.type}}
                        data-pack={{@root.config.HELP.action.resources.pack}}
                        data-tooltip="Documentation: Action: Resources"><i
                            class="{{@root.config.HELP.action.resources.icon}}"></i></a>
                </div>
                <div class="action-resource-trunc">
                    <select class="action-resource-type" name="resource.type">
                        {{selectOptions config.resources selected=action.resource.type localize=true}}
                    </select>
                </div>
                {{#ifnoteq action.resource.type 'none'}}
                    {{#if (eq action.resource.type 'charged')}}
                        <div class="action-resource-trunc">
                            <select class="action-resource-reuse" name="resource.reusetime">
                                {{selectOptions config.reusetime selected=action.resource.reusetime localize=true}}
                            </select>
                        </div>
                    {{/if}}
                    <div class="action-resource-cost">
                        <input size="4" name="resource.count.cost" type="text" value="{{action.resource.count.cost}}"
                            data-dtype="Number" />
                    </div>

                    {{!-- {{#if (eq action.resource.type 'item')}} --}}
                    {{#includes action.resource.type "item||powered"}}
                        <div class="action-resource-trunc">
                            {{#if @root.actor.inventory}}
                                <select class="action-resource-item" name="resource.itemId">
                                    <option value="">{{localize "ARS.none"}}</option>
                                    {{selectOptions @root.actor.inventory selected=action.resource.itemId valueAttr="id" labelAttr="name" localize=true}}
                                </select>
                            {{else}}
                                <label>{{localize "ARS.noinventory"}}</label>
                            {{/if}}

                        </div>
                    {{/includes}}
                    {{!-- {{/if}} --}}

                    {{#if (eq action.resource.type 'charged')}}
                        <div class="action-resource-value">
                            <input size="4" name="resource.count.value" type="text"
                                value="{{action.resource.count.value}}" data-dtype="Number" />
                        </div>
                        <div class="action-resource-max">
                            <input size="4" name="resource.count.max" type="text"
                                value="{{action.resource.count.max}}" />
                        </div>
                    {{/if}}
                {{/ifnoteq}}
            </li>
        </div>

    </div>

    {{#ifnoteq action.type  'use'}}
        <div class="action-list action-save">
            <li class="action-header flexrow">
                <div class="actions-save-title-name">Save</div>
                <div class="action-save-type">Type</div>
                <div class="action-save-formula">Formula</div>
            </li>

            <div class="actions-save">
                <li class="action-save flexrow">
                    <div class="actions-save-title-name"></div>
                    <div class="action-save">
                        <select class="action-save-type" name="saveCheck.type">
                            {{selectOptions config.saveTypes selected=action.saveCheck.type localize=true}}
                        </select>
                    </div>
                    <div class="action-save-formula">
                        <input name="saveCheck.formula" type="text" value="{{action.saveCheck.formula}}"
                            placeholder="+0" />
                    </div>
                </li>
            </div>
        </div>

        <div class="action-list action-check">
            <li class="action-header flexrow">
                <div class="actions-check-title-name">Check</div>
                <div class="action-check-type">Type</div>
                <div class="action-check-formula">Formula</div>
            </li>

            <div class="actions-check">
                <li class="action-check flexrow">
                    <div class="actions-check-title-name"></div>
                    <div class="action-check">
                        <select class="action-check-type" name="abilityCheck.type">
                            {{selectOptions config.abilityTypes selected=action.abilityCheck.type localize=true}}
                        </select>
                    </div>

                    <div class="action-check-formula">
                        <input name="abilityCheck.formula" type="text" value="{{action.abilityCheck.formula}}"
                            placeholder="1d20" />
                    </div>
                </li>
            </div>
        </div>
    {{/ifnoteq}}
{{/includes}}

{{#includes action.type "castshape"}}
    <div class="action-list">
        <div class="general-header resource-title-name">{{localize "ARS.actions.castshape.template"}}</div>
        <div class="general-subheader flexrow">
            <div style="flex: 0 0 100px" class="action-resource-shape">
                {{localize "ARS.actions.castshape.shape"}}
            </div>
            {{#if (eq action.castShape.shape.type 'none') }}
            {{else}}
                {{#if (eq action.castShape.shape.type 'cone') }}
                    <div style="flex: 0 0 100px" class="action-resource-shape-cone-type">
                        {{localize "ARS.actions.castshape.conetype"}}
                    </div>
                    {{#if (eq action.castShape.coneShape.type 'ratio') }}
                        <div class="action-resource-width">Width</div>
                        <div class="action-resource-length">Length</div>
                    {{else}}
                        <div class="action-resource-angle">Angle</div>
                        <div class="action-resource-length">Length</div>
                    {{/if}}
                {{/if}}
                {{#if (eq action.castShape.shape.type 'circle') }}
                    <div class="action-resource-radius">Radius</div>
                {{/if}}
                {{#if (eq action.castShape.shape.type 'ray') }}
                    <div class="action-resource-length">Length</div>
                    <div class="action-resource-length">Width</div>
                {{/if}}

                {{#if (eq action.castShape.shape.type 'ray2') }}
                    <div class="action-resource-length">Length</div>
                    <div class="action-resource-length">Width</div>
                {{/if}}

                {{#if (eq action.castShape.shape.type 'rectangle') }}
                    <div class="action-resource-length">Length</div>
                    <div class="action-resource-length">Width</div>
                {{/if}}
            {{/if}}
        </div>
        <div class="actions-list actions-list-data flexrow">
            <select class="action-targetShape-type" style="flex: 0 0 100px;width: 100px;" name="castShape.shape.type">
                {{selectOptions config.targetShape selected=action.castShape.shape.type localize=true}}
            </select>

            {{#if (eq action.castShape.shape.type 'circle')}}
                <div class="cast-shape-radius">
                    <input name="castShape.properties.radius.formula" type="text"
                        value="{{action.castShape.properties.radius.formula}}" placeholder="+0" />
                </div>

            {{/if}}
            {{#if (eq action.castShape.shape.type 'cone')}}
                <select class="action-coneShape-type" style="flex: 0 0 100px;width: 100px;"
                    name="castShape.coneShape.type">
                    {{selectOptions config.targetShapeConeType selected=action.castShape.coneShape.type localize=true}}
                </select>
                {{#if (eq action.castShape.coneShape.type 'ratio')}}
                    <div class="cast-shape-width">
                        <input name="castShape.properties.width.formula" type="text"
                            value="{{action.castShape.properties.width.formula}}" placeholder="+0" />
                    </div>
                    <div class="cast-shape-length">
                        <input name="castShape.properties.length.formula" type="text"
                            value="{{action.castShape.properties.length.formula}}" placeholder="+0" />
                    </div>
                {{else}}
                    <div class="cast-shape-angle">
                        <input name="castShape.properties.angle.formula" type="text"
                            value="{{action.castShape.properties.angle.formula}}" placeholder="+0" />
                    </div>
                    <div class="cast-shape-length">
                        <input name="castShape.properties.length.formula" type="text"
                            value="{{action.castShape.properties.length.formula}}" placeholder="+0" />
                    </div>
                {{/if}}
            {{/if}}
            {{#if (eq action.castShape.shape.type 'ray')}}
                <div class="cast-shape-length">
                    <input name="castShape.properties.length.formula" type="text"
                        value="{{action.castShape.properties.length.formula}}" placeholder="+0" />
                </div>
                <div class="cast-shape-width">
                    <input name="castShape.properties.width.formula" type="text"
                        value="{{action.castShape.properties.width.formula}}" placeholder="+0" />
                </div>
            {{/if}}


            {{#if (eq action.castShape.shape.type 'ray2')}}
                <div class="cast-shape-length">
                    <input name="castShape.properties.length.formula" type="text"
                        value="{{action.castShape.properties.length.formula}}" placeholder="+0" />
                </div>
                <div class="cast-shape-width">
                    <input name="castShape.properties.width.formula" type="text"
                        value="{{action.castShape.properties.width.formula}}" placeholder="+0" />
                </div>
            {{/if}}

            {{#if (eq action.castShape.shape.type 'rectangle')}}
                <div class="cast-shape-length">
                    <input name="castShape.properties.length.formula" type="text"
                        value="{{action.castShape.properties.length.formula}}" placeholder="+0" />
                </div>
                <div class="cast-shape-width">
                    <input name="castShape.properties.width.formula" type="text"
                        value="{{action.castShape.properties.width.formula}}" placeholder="+0" />
                </div>

            {{/if}}
        </div>

        <div class="general-subheader flexrow">
            <div class="in-range-color">
                {{localize "ARS.actions.castshape.inRangeColor"}}
            </div>
            <div class="out-range-color">
                {{localize "ARS.actions.castshape.outOfRangeColor"}}
            </div>
        </div>

        <div>
            <div class="flexrow">
                {{#if action.castShape.properties.inRangeColor}}
                    <input type="color" value="{{action.castShape.properties.inRangeColor}}" placeholder="#696df2"
                        data-edit="castShape.properties.inRangeColor" />
                    <input type="text" value="{{action.castShape.properties.inRangeColor}}" placeholder="#696df2"
                        name="castShape.properties.inRangeColor" />
                {{else}}
                    <input type="color" value="#696df2" placeholder="#696df2"
                        data-edit="castShape.properties.inRangeColor" />
                    <input type="text" value="#696df2" placeholder="#696df2" name="castShape.properties.inRangeColor" />
                {{/if}}

                {{#if action.castShape.properties.outOfRangeColor}}
                    <input type="color" value="{{action.castShape.properties.outOfRangeColor}}" placeholder="#a80000"
                        data-edit="castShape.properties.outOfRangeColor" />
                    <input type="text" value="{{action.castShape.properties.outOfRangeColor}}" placeholder="#a80000"
                        name="castShape.properties.outOfRangeColor" />
                {{else}}
                    <input type="color" value="#a80000" placeholder="#a80000"
                        data-edit="castShape.properties.outOfRangeColor" />
                    <input type="text" value="#a80000" placeholder="#a80000"
                        name="castShape.properties.outOfRangeColor" />

                {{/if}}
            </div>
        </div>

    </div>
{{/includes}}

{{#if (eq action.type 'damage')}}
    <div class="action-damageother-header resource-title">
        <div class="action-damageother-header">
            <div class="action-damageother-title">
                <h4>Additional Damage<a align="right" class="item-control action-control add-damage"><i align="right"
                            class="fas fa-plus"></i></a></h4>
            </div>
        </div>
    </div>
    <div class="action-damageother">
        {{#checklength action.otherdmg 0}}
            <div class="action-titles">
                <div class="action-header flexrow">
                    <div class="action-damageother-type">Type</div>
                    <div class="action-damageother-formula">Formula</div>
                    <div class="action-damageother-remove"></div>
                </div>
            </div>
            {{#each action.otherdmg as |dmg index| }}
                <div class="actions-damageother">
                    <li class="action-damageother flexrow">
                        <div class="action-damageother">
                            <select class="action-damageother-type" name="otherdmg.{{index}}.type">
                                {{selectOptions ../config.weaponDamageTypes selected=dmg.type localize=true}}
                            </select>
                        </div>
                        <div class="action-damageother-formula">
                            <input type="text" name="otherdmg.{{index}}.formula" value="{{dmg.formula}}" />
                        </div>
                        <div class="action-damageother-remove action-controls">
                            <a class="item-control action-control delete-damage" data-index={{index}}> <i
                                    class="fas fa-minus"> </i></a>
                        </div>
                    </li>
                </div>
            {{/each}}
        {{/checklength}}
    </div>
{{/if}}

{{!-- {{Heal specific section}} --}}
{{#if (eq action.type 'heal')}}
{{/if}}

{{!-- {{Use specific section}} --}}
{{#if (eq action.type 'use')}}
{{/if}}

{{!-- {{Effect specific section}} --}}
{{#includes action.type 'effect||item-effect'}}
    <div class="action-titles">
        <div class="action-header flexrow">
            <div class="action-effect-durationformula">Duration Formula</div>
            <div class="action-effect-durationtype">Type</div>
            <div class="action-effect-application">{{localize 'ARS.actions.apply.self'}}</div>
            <div class="action-effect-visibility">{{localize 'ARS.actions.visibility'}}</div>
        </div>
    </div>
    <div>
        <li class="action-effect-duration flexrow">

            <div class="action-effect-durationformula">
                <input type="text" name="effect.duration.formula" value="{{action.effect.duration.formula}}" />
            </div>
            <div class="action-effect-durationtype">
                <select class="action-effect-duration-type" name="effect.duration.type">
                    {{selectOptions config.actions.durationTypes selected=action.effect.duration.type localize=true}}
                </select>
            </div>

            {{!-- apply to self --}}
            <div class="action-effect-durationtype">
                <label class="ars-switch">
                    <input type="checkbox" id="applyself" name="effect.system.applyself" {{ checked action.effect.system.applyself }}>
                    <span class="slider"></span>
                </label>
            </div>

            {{!-- visibility of effect --}}
            <select class="action-effect-visibility" name="effect.system.visibility">
                {{selectOptions config.actions.effect_visibility selected=action.effect.system.visibility localize=true}}
            </select>
        </li>
    </div>
    <div class="action-titles action-changes-list">
        <div class="action-header flexrow">
            <div style="flex-grow: 2;" class="key">{{ localize "ARS.key" }}</div>
            <div style="flex: 0 0 100px" class="mode">{{ localize "ARS.mode" }}</div>
            <div style="flex-grow: 2;" class="value">{{ localize "ARS.value" }}</div>
            <div class="effect-controls">
                <a class="effect-control" data-action="add"><i class="far fa-plus-square"></i></a>
            </div>
        </div>
        <div class="changes-list">
            {{#each action.effect.changes as |change i|}}
                <li class="effect-change flexrow" data-index="{{i}}">

                    <div style="flex-grow: 2;" class="key">
                        <input class="effect-change-key" list="predefinedOptions_{{@root.action.id}}" type="text"
                            name="effect.changes.{{i}}.key" value="{{change.key}}" />
                        <datalist class="action-effect-change-key" id="predefinedOptions_{{@root.action.id}}">
                            {{#each @root.selectEffectKeys}}
                                <option value="{{this.name}}">
                            {{/each}}
                        </datalist>
                    </div>
                    <div class="action-resource-trunc mode">
                        <select class="action-effect-change" name="effect.changes.{{i}}.mode" data-dtype="Number">
                            {{selectOptions ../config.actions.effect_modes selected=change.mode localize=true}}
                        </select>
                    </div>
                    <div style="flex-grow: 2;" class="value">
                        <div class="cm-toolbar">
                            <button id="format-code">Format Code</button>
                            <button id="close">Close</button>
                        </div>
                        <textarea class="code-editor effect-editor action-effect-value" type="text"
                            name="effect.changes.{{i}}.value" value="{{change.value}}">{{change.value}}</textarea>
                    </div>
                    <div class="effect-controls" style="flex: 0 0 40px;">
                        <a class="effect-control" data-action="delete"><i class="fas fa-trash"></i></a>
                        <a class="effect-control cm-launch" title="Launch Code Editor" style="margin-right: 3px;"
                            data-action="edit"><i class="fas fa-edit"></i></a>
                    </div>
                </li>
            {{/each}}
        </div>
    </div>
{{/includes}}

{{#if (eq action.type 'damage')}}
    {{#if (eq this.item.type 'weapon')}}
        <div>
            <div class="action-potency-section flexrow">
                <div class="action-properties-title">{{ localize "ARS.resistTypes.magicpotency" }}</div>
                <div><input name="magicpotency" value="{{action.magicpotency}}" data-dtype="Number" /></div>
            </div>
        </div>
        {{!-- <div class="damage-properties">
            {{> "systems/ars/templates/apps/parts/action-properties-block.hbs"}}
        </div> --}}
    {{/if}}
{{/if}}

{{!-- macros and scripts --}}
{{#includes action.type 'macro'}}
<div class="action-macro effect-change">
    <div class="action-macro effect-change">
        <label for="macro-id-hit">Enter Macro Id or JS:</label>
        <div>
            <div class="cm-toolbar">
                <button id="format-code">Format Code</button>
                <button id="close">Close</button>
            </div>
            <textarea id="embedded-script" class="code-editor effect-editor action-effect-value" style="width: 100%;"
                name="macro.script">{{action.macro.script}}</textarea>
        </div>

        <div class="effect-controls" style="flex: 0 0 40px;">
            <a class="effect-control" data-action="delete"><i class="fas fa-trash"></i></a>
            <a class="effect-control cm-launch" title="Launch Code Editor" style="margin-right: 3px;" data-action="edit">
                <i class="fas fa-edit"></i>
            </a>
        </div>
    </div>
</div>
{{/includes}}

{{!-- {{#includes action.type 'cast||castmelee||castranged'}} --}}
<div class="action-properties">
    {{> "systems/ars/templates/apps/parts/action-properties-block.hbs"}}
</div>
{{!-- {{/includes}} --}}